const domUtil = new DomUtil('#article')

function useEditorContent(details , netstutas, networkSwitch, audioState) {
  const { start, scrollTo } = useScroll()
  const { imageLoaded, initImage, remove: removeImage } = useImage(details)
  const { start: startAudio, remove: removeAudio, audioPlayNum } = useAudio(audioState)
  const { start: startEchart, echartRemove } = useEchart()
  const { startSwiper, addSwiper, remove: removeSwiper } = useSwiper()
  const { startSwiperPoster, addSwiperPoster, remove: removeSwiperPoster } = useSwiperPoster()
  const { initVideo, addVideoList, removeDpVideo, videoLoaded } = useVideo(netstutas , networkSwitch, audioState, details, audioPlayNum)

  watch(imageLoaded, (val) => {
    if (val) {
      // changeContentHtmlHeight()
    }
  })

  watch(videoLoaded, (val) => {
    if (val) {
      // changeContentHtmlHeight()
    }
  })

  const startSwiperText = () => {
    const basicWidth = getTextWidth('Trucks wait to load containers at a container terminal in Rizhao。', {
      fontSize: '0.32rem',
      whiteSpace: 'nowrap',
      paddingLeft: '1.06666667rem'
    })
    const swiperText = document.querySelectorAll('.content .en-scroll-text .swiper-txet')
    for (let i = 0; i < swiperText.length; i++) {
      const leftWidth = swiperText[i].parentNode.querySelector('.scroll-text-left').getBoundingClientRect().width
      const allWidth = document.querySelector('#newsTitle').getBoundingClientRect().width - leftWidth
      const width = swiperText[i].getBoundingClientRect().width
      const keyframes = document.createElement('style')
      document.head.appendChild(keyframes)
      const keyframesSheet = keyframes.sheet
      const rate = 10 / (allWidth + basicWidth)
      const firstDuration =  rate * width

      // 定义关键帧的样式
      const frameStyles = `0% {transform: translateX(0%);}100% {transform: translateX(calc(${-width}px + 44px));}`
      const frameStyless = `0% {transform: translateX(calc(${allWidth}px - 12px));}100% {transform: translateX(calc(${-width}px + 44px));}`

      // 添加关键帧到样式表中
      keyframesSheet.insertRule(`@keyframes swiperText${i} { ${frameStyles} }`, 0)
      keyframesSheet.insertRule(`@keyframes swiperTextIn${i} { ${frameStyless} }`, 1)
      // @ts-ignore
      swiperText[i].style.animation = `swiperText${i} ${firstDuration}s linear`
      // @ts-ignore
      swiperText[i].style.animationDelay = `.5s`
      setTimeout(() => {
        // @ts-ignore
        swiperText[i].style.animation = `swiperTextIn${i} ${rate * (allWidth + width)}s linear infinite`
        // @ts-ignore
        swiperText[i].style.animationDelay = `0`
      }, firstDuration * 1000 + 500)
    }
  }

  const handleArticleStr = () => {
    try {
      domUtil.handleArticleStr(details.value.newsContent || '', (type, option) => {
        if (type === 1) {
        } else if (type === 2) {
          addVideoList(option)
        } else if (type === 3) {
          addSwiper(option)
        } else if (type === 4) {
          addSwiperPoster(option)
        }
      }, details.value)
      domUtil.cloneToContent()
      startSwiperText()
      if (details.value.newsContentBak) {
        try {
          startEchart(JSON.parse(details.value.newsContentBak))
        } catch (e) {}
      }
      start()

      document.querySelector('.content-block .content').classList.add('active')
      document.querySelector('.content-block .content-loading').classList.remove('active')
    } catch (e) {
      console.log(e)
    }
  }

  const addLinkClick = () => {
    const aEl = document.querySelectorAll('.content a')
    for (let i = 0; i < aEl.length; i++) {
      addEventListenerWrap(aEl[i], 'click', (_) => {
        const peopleOrigin = [
          'peoplesdaily.pdnews.cn',
          'overseas.pdnews.cn',
          'pd-eos-sit.pdnews.cn',
          'pd-eos-uat.pdnews.cn',
        ]
        let url = aEl[i].getAttribute('data-href')
        if (peopleOrigin.some(origin => url.includes(origin))) {
          if (!url.includes('isIner=0')) {
            if (url.includes('?')) {
              if (url[url.length - 1] !== '?') {
                url = `${url}&isIner=0`
              } else if (url[url.length - 1] === '?') {
                url = `${url}isIner=0`
              }
            } else {
              url = `${url}?isIner=0`
            }
          }
        }
        try {
          if (window.config.VUE_BASE_NODE === 'dev') {
            window.open(url)
          } else {
            sendNative(
              'jsCall_appInnerLinkMethod',
              {
                appInnerLink: `peopledailyen://rmrb.app/openwith?type=h5&url=${encodeURIComponent(url)}&skipType=3`
              }
            )
          }
        } catch(e) {}
      })
    }
  }

  const initEditorStr = () => {
    handleArticleStr()

    addLinkClick()
    initImage()
    initVideo()
    startAudio()
    startSwiper()
    startSwiperPoster()
  }

  const refreshEditorStr = () => {
    scrollTo(0)
    removeDpVideo()
    removeImage()
    echartRemove()
    removeAudio()
    removeSwiper()
    removeSwiperPoster()
    mobileLoadingBlock(true)
    mobileApp(false)
    domUtil.clearHtml()
  }

  return {
    initEditorStr,
    refreshEditorStr
  }
}
