const { ref, reactive, watch, computed  } = Vue

function useScroll() {
  const scrollEvent = ref()
  const internalY = ref(0)

  const directions = reactive({
    top: false,
    bottom: false
  })

  const handleScroll = (e, callBack) => {
    const eventTarget = e.target === document ? e.target.documentElement : e.target
    const scrollTop = eventTarget.scrollTop
    directions.top = scrollTop < internalY.value
    directions.bottom = scrollTop > internalY.value
    internalY.value = scrollTop

    try {
      sendNative('jsCall_h5ScrollEvent', { openH5ScrollEvent: '1', scrollingDirection: directions.top ? '1' : '2' }, () => {})
    } catch (error) {
    }
    if (callBack) callBack(e)
  }

  const scrollTo =(top) => {
    document.querySelector('body #app').scrollTo({
      top
    })
  }

  const start = (callBack) => {
    scrollEvent.value = addEventListenerWrap(document.querySelector('body #app'), 'scroll', e => handleScroll(e, callBack))
  }

  return {
    start,
    scrollTo,
    internalY,
    scrollEvent,
    directions
  }
}
