function clickContainer(player, events) {
  if (player.player) {
    events.proxy(player.template.$video, 'click', (e) => {

      if (!events.initVideo) {
        return
      }
      if (events.dragFixed) {
        player.player.pause()
        events.layerDom.toggleCommonLayer(player.template.$miniLayer, true)
      } else {
        if (player.player.getStatus() === 'playing' || player.player.getStatus() === 'pause') {
          events.clearSetTimeOut()
          if (hasClass(player.template.$container.parentNode, 'init')) { return }
          if (hasClass(player.template.$bottom, 'none')) {
            events.layerDom.tooglePlayerBottom(true)
            events.layerDom.tooglePlayerBottom(false, true)
          } else {
            events.layerDom.tooglePlayerBottom(false)
          }
        }
      }
    })
  }
}

function clickErrorBlock(player, events) {
  if (player.player) {
    events.proxy(player.template.$error, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()
    })
  }
}


function clickErrorBtn(player, events) {
  if (player.player) {
    events.proxy(player.template.$errorBtn, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()
    })
  }
}

function clickNetworkBlock(player, events) {
  if (player.player) {
    events.proxy(player.template.$network, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()
    })
  }
}

function clickNetworkBlockBtn(player, events) {
  if (player.player) {
    events.proxy(player.template.$networkBtn, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()

      if (!events.dragFixed) {
        events.clearSetTimeOut()

        removeClass(player.template.$container.parentNode, 'init')

        player.callBackFun.continueNetwork()

        events.layerDom.toggleLayerPause(false)

        events.layerDom.tooglePlayerBottom(true)

        events.layerDom.tooglePlayerBottom(false, true)

        player.player.play()

        setTimeout(() => {
          player.player.play()
        }, 100)

        if (window.config.VUE_BASE_NODE === 'dev') {
        } else {
          try {
            sendNative('jsCall_currentPageOperate', {
              operateType: '4'
            })
          } catch (e) {}
        }
      }
    })
  }
}

function clickLayerStateBlock(player, events) {
  if (player.player) {
    events.proxy(player.template.$layerState, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()

      if (!events.dragFixed) {
        events.clearSetTimeOut()
        if (player.player.getStatus() !== 'playing') {
          if (hasClass(player.template.$container.parentNode, 'init')) {
            removeClass(player.template.$container.parentNode, 'init')
          }

          events.firstPlay = true
          player.player.play()
          events.layerDom.toggleLayerPause(false)
          events.layerDom.tooglePlayerBottom(true)
          events.layerDom.tooglePlayerBottom(false, true)
          player.callBackFun.closeFixModal()
        } else if (player.player.getStatus() === 'playing') {
          player.player.pause()
          events.layerDom.toggleCommonLayer(player.template.$miniLayer, true)
          events.layerDom.toggleLayerPause(true)
          events.layerDom.tooglePlayerBottom(false, true)
        }
      }
    })
  }
}

function clickLayerStateBtn(player, events) {
  if (player.player) {
    events.proxy(player.template.$layerStateBtn, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()

      if (!events.dragFixed) {
        events.clearSetTimeOut()
        if (hasClass(player.template.$container.parentNode, 'init')) {
          removeClass(player.template.$container.parentNode, 'init')
        }

        events.firstPlay = true
        events.layerDom.toggleLayerPause(false)
        events.layerDom.tooglePlayerBottom(true)
        events.layerDom.tooglePlayerBottom(false, true)
        player.callBackFun.closeFixModal()
      }
    })
  }
}

function clickBottomState(player, events) {
  if (player.player) {
    events.proxy(player.template.$bottomState, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()

      if (player.player) {

        if (!events.dragFixed) {
          events.layerDom.tooglePlayerBottom(true)
          events.clearSetTimeOut()
          if (player.player.getStatus() === 'playing') {
            player.player.pause()
            player.template.$bottomState.setAttribute('src', './image/player/video_puse.svg')
          } else {
            player.player.play()
            player.template.$bottomState.setAttribute('src', './image/player/video_play.svg')
          }
          events.layerDom.tooglePlayerBottom(false, true)
        }
      }
    })
  }
}

function clickBottonFullScreen(player, events) {
  if (player.player) {
    events.proxy(player.template.$bottomFullScreen, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()

      if (!events.dragFixed) {
        events.layerDom.tooglePlayerBottom(true)
        events.clearSetTimeOut()

        if (player.player.fullscreenService.getIsFullScreen()) {
          const bg = player.template.$container.getAttribute('old-bg')
          player.template.$container.setAttribute('old-bg', '')
          player.template.$container.style.backgroundColor = bg
          player.player.fullscreenService.cancelFullScreen()
        } else {
          player.player.fullscreenService.requestFullScreen()
          player.template.$container.setAttribute('old-bg', player.template.$container.style.backgroundColor)
          player.template.$container.style.backgroundColor = '#000'
        }

        events.layerDom.tooglePlayerBottom(false, true)
      }
    })
  }
}

function clickReplayBlock(player, events) {
  if (player.player) {
    events.proxy(player.template.$replay, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()
    })
  }
}

function clickReplayBtn(player, events) {
  if (player.player) {
    events.proxy(player.template.$replayBtn, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()

      if (!events.dragFixed) {
        events.clearSetTimeOut()
        player.template.$video.currentTime = 0
        player.template.$video.play()

        player.events.playerEnd = false

        events.layerDom.toggleCommonLayer(player.template.$replay, false)

        events.layerDom.toggleBottomPlayState(true)

        events.layerDom.tooglePlayerBottom(true)

        events.layerDom.tooglePlayerBottom(false, true)
      }
    })
  }
}

function clickMiniLayerBlcok(player, events) {
  if (player.player) {
    events.proxy(player.template.$miniLayer, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()

      if (player.player.getStatus() === 'pause') {
        player.player.play()
        events.layerDom.toggleCommonLayer(player.template.$miniLayer, false)
      } else if (player.player.getStatus() === 'playing') {
        player.player.pause()
        events.layerDom.toggleCommonLayer(player.template.$miniLayer, true)
      }
    })
  }
}

function clickMiniLayerBtn(player, events) {
  if (player.player) {
    events.proxy(player.template.$miniLayerBtn, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()

      player.player.play()

      events.layerDom.toggleCommonLayer(player.template.$miniLayer, false)
    })
  }
}

function clickMiniCloseBtn(player, events) {
  if (player.player) {
    events.proxy(player.template.$miniClose, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()

      if (events.dragFixed) {
        player.callBackFun.closeFixModal(player.options.record.id)
      }
    })
  }
}
