let id = 0

class videoEnPlayer extends Emitter {
  constructor(options) {
    super()

    this.options = options.config
    this.callBackFun = options.callBackFun

    this.id = ++id
    this.player = null
    this.poster = ''
    this.originPoster = ''
    this.isDestroy = false
    this.container = document.querySelector(`#video-player-${this.options.key}`)

    this.initOhtersPlayer()

    this.template = new Template(this)
    this.events = new Events(this)
  }

  get proxy() {
    return this.events.proxy
  }

  get query() {
    return this.template.query
  }

  initOhtersPlayer() {
    const domId = this.container.getAttribute('id')
    const url = this.options.record.url
    const isDark = document.querySelector('html').getAttribute('dark-mode') === 'true'
    this.poster = this.options.record.poster
    this.originPoster = this.options.record.poster

    const cdnUrl = [
      'cdnpdcontent.aikan.pdnews.cn',
      'cdnpdcontentsit.aikan.pdnews.cn',
      'cdnpdcontentuat.aikan.pdnews.cn'
    ]

    if (!this.poster && cdnUrl.some(el => url.includes(el))) {
      this.poster = `${url}?x-oss-process=video/snapshot,t_0,f_jpg`
      this.originPoster = `${url}?x-oss-process=video/snapshot,t_0,f_jpg`
    }

    if (!this.poster) {
      this.poster = isDark ? './image/placeHoldVlogo.svg' : './image/placeholdLogo.svg'
    }

    this.player = new Aliplayer({
      id: domId,
      cover: this.poster,
      language: 'en-us',
      autoplay: true,
      x5_type: true,
      source: url
    })
  }

  destroy() {
    this.isDestroy = true
    this.events.destroy()

    if (this.player) {
      this.player.dispose()
    }

    this.player = null
  }
}
