class DomUtil {
  constructor(dom) {
    this.dom = dom
  }

  $dom(dom, all) {
    return document[all ? 'querySelectorAll' : 'querySelector'](dom || this.dom)
  }

  clearHtml() {
    $('.gx-mobile .content').html('')
    this.$dom().innerHTML = ''
  }

  handleArticleStr(str, nextCallback, details) {
    if (!str) return ''
    document.querySelector('#originArticle').innerHTML = str

    this.$dom().innerHTML = ''
    this.$dom().innerHTML = str

    const centerDom = document.querySelectorAll('#article center')

    for (let i = 0; i < centerDom.length; i++) {
      const html = centerDom[i].innerHTML
      const el = document.createElement('p')
      el.innerHTML = html
      centerDom[i].before(el)
      centerDom[i].remove()
    }

    const imageDom = this.$dom('#article img', true)
    const videoDom = this.$dom('#article video', true)
    const audioDom = document.querySelectorAll('#article [class^="audio-block"]')
    const linkCardDom = document.querySelectorAll('#article .linkcard')
    const swiperDom = document.querySelectorAll('#article ._editor16')
    const swiper2Dom = document.querySelectorAll('#article ._editor27')
    const leftOrRight = document.querySelectorAll(`#article section[data-title='左文右图']`)
    const leftOrRight2 = document.querySelectorAll(`#article section[data-title='左图右文']`)
    const imgPut = document.querySelectorAll('#article .edit_img_input')
    const imgPut2 = document.querySelectorAll('#article .imageCaption')

    const swiperText = document.querySelectorAll(`#article section[data-title='文字滚动']`)
    const tableDom = document.querySelectorAll('#article ._editor24')

    const text1Dom = document.querySelectorAll(`#article section[data-title='文本框1']`)
    const text2Dom = document.querySelectorAll(`#article section[data-title='文本框2']`)
    const text3Dom = document.querySelectorAll(`#article section[data-title='文本框3']`)
    const text4Dom = document.querySelectorAll(`#article section[data-title='文本框4']`)
    const text5Dom = document.querySelectorAll(`#article section[data-title='文本框5']`)

    const textChangeDom = document.querySelectorAll(`#article section[data-title='文字切换']>div`)
    const textSplit5Dom = document.querySelectorAll(`#article section[data-title='分割线-5']>div`)

    const brDom = document.querySelectorAll(`#article p > br`)

    // 处理分割线5
    for (let i = 0; i < textSplit5Dom.length; i++) {
      if (textSplit5Dom[i].querySelector('div#sign')) {
        const isDark = document.querySelector('html').getAttribute('dark-mode') === 'true'
        textSplit5Dom[i].querySelector('div#sign').style.background = isDark ? '#161827' : '#fff'
      }
    }

    // 处理换行的间距
    for (let i = 0; i < brDom.length; i++) {
      if (brDom[i].parentNode) {
        if (brDom[i].parentNode.childNodes && brDom[i].parentNode.childNodes.length === 1) {
          if (brDom[i].parentNode.childNodes[0].tagName === 'BR') {
            brDom[i].parentNode.setAttribute('style', 'margin-bottom: 0 !important;height: 0 !important;')
          }
        }
      }
    }

    // 处理文字切换
    for (let i = 0; i < textChangeDom.length; i++) {
      textChangeDom[i].style.width = '100%'
    }

    // 处理文本1
    for (let i = 0; i < text1Dom.length; i++) {
      let title = ''
      let bgHex = ''
      let borderColor = ''
      const el = document.createElement('div')
      el.classList.add('en-text-1')
      const borderEl = text1Dom[i].querySelector('div#border')
      const titleEl = text1Dom[i].querySelector('p#content')
      if (titleEl) {
        title = titleEl.textContent
      }

      if (borderEl) {
        bgHex = borderEl.style.backgroundColor
        borderColor = borderEl.style.borderInlineStartColor
      }
      el.style.borderLeftColor = borderColor
      el.style.backgroundColor = bgHex
      el.innerHTML = `<div class="en-text-1-title">${title}<img src="./image/textDesIcon.svg" alt=""></div>`
      text1Dom[i].before(el)
      text1Dom[i].remove()
    }

    // 处理文本2
    for (let i = 0; i < text2Dom.length; i++) {
      let title = ''
      let borderColor = ''
      const el = document.createElement('div')
      el.classList.add('en-text-2')
      const borderEl = text2Dom[i].querySelector('div#border')
      const titleEl = text2Dom[i].querySelector('div#content')
      if (titleEl) {
        title = titleEl.textContent
      }

      if (borderEl) {
        borderColor = borderEl.style.borderColor
      }
      el.style.borderColor = borderColor
      el.innerHTML = `<div class="en-text-2-title" style="border-color: ${borderColor}">${title}</div>`
      text2Dom[i].before(el)
      text2Dom[i].remove()
    }

    // 处理文本3
    for (let i = 0; i < text3Dom.length; i++) {
      let title = ''
      let content = ''
      let titleColor = ''
      let borderColor = ''
      const el = document.createElement('div')
      el.classList.add('en-text-3')
      const borderEl = text3Dom[i].querySelector('div#border')
      const titleEl = text3Dom[i].querySelector('span#title')
      const contentEl = text3Dom[i].querySelector('p#content')
      if (titleEl) {
        titleColor = titleEl.style.color
        title = titleEl.textContent
      }

      if (borderEl) {
        borderColor = borderEl.style.borderColor
      }

      if (contentEl) {
        content = contentEl.textContent
      }

      el.style.borderColor = borderColor
      el.innerHTML = `<div class="en-text-3-title droidSerif-bold" style="color: ${titleColor}"><i class="en-text-3-point" style="background: ${borderColor}"></i>${title}</div><div class="en-text-3-content">${content}</div>`
      text3Dom[i].before(el)
      text3Dom[i].remove()
    }

    // 处理文本4
    for (let i = 0; i < text4Dom.length; i++) {
      let title = ''
      let bgHex = ''
      let titleColor = ''
      const el = document.createElement('div')
      el.classList.add('en-text-4')
      const borderEl = text4Dom[i].querySelector('div#border')
      const titleEl = text4Dom[i].querySelector('h4#title')
      if (titleEl) {
        title = titleEl.textContent
        titleColor = titleEl.style.color
      }

      if (borderEl) {
        bgHex = borderEl.style.backgroundColor
      }
      el.style.backgroundColor = bgHex
      el.innerHTML = `<div class="en-text-4-title droidSerif-bold" style="color: ${titleColor}">${title}</div><div class="en-text-4-end" style="background: ${bgHex}"></div>`
      text4Dom[i].before(el)
      text4Dom[i].remove()
    }

    // 处理文本5
    for (let i = 0; i < text5Dom.length; i++) {
      let title = ''
      let titleBg = ''
      let titleColor = ''
      let num = ''
      let numBg = ''
      let numColor = ''
      const el = document.createElement('div')
      el.classList.add('en-text-5')
      const borderEl = text5Dom[i].querySelector('div#border')
      const numEl = text5Dom[i].querySelector('div#sign')
      if (numEl) {
        num = numEl.textContent
        numBg = numEl.style.backgroundColor
        numColor = numEl.style.color
      }
      const titleEl = text5Dom[i].querySelector('h4#title')
      if (titleEl) {
        title = titleEl.textContent
        titleColor = titleEl.style.color
      }

      if (borderEl) {
        titleBg = borderEl.style.backgroundColor
      }
      el.innerHTML = `<div class="en-text-5-block"><div class="en-text-5-num droidSerif-bold" style="color: ${numColor}; background: ${numBg}">${num}</div><div style="color: ${titleColor}; background: ${titleBg}" class="en-text-5-title droidSerif-bold">${title}</div></div>`
      text5Dom[i].before(el)
      text5Dom[i].remove()
    }

    // 处理表格
    for (let i = 0; i < tableDom.length; i++) {
      let title = ''
      const el = document.createElement('div')
      el.classList.add('en-table')
      const titleEl = tableDom[i].querySelector('span:first-child')
      if (titleEl) {
        title = titleEl.textContent
      }
      const tableHtml = tableDom[i].querySelector('table').innerHTML
      const tableStyle = tableDom[i].querySelector('table').getAttribute('style')
      el.innerHTML = `<div class="en-table-title droidSerif-bold">${title}</div><table style="${tableStyle}">${tableHtml}</table>`
      tableDom[i].before(el)
      tableDom[i].remove()
    }

    // 处理轮播字幕
    for (let i = 0; i < swiperText.length; i++) {
      const el = document.createElement('div')
      el.classList.add('en-scroll-text')
      let text = ''
      let imgSrc = ''
      const textEl = swiperText[i].querySelector('tspan')
      const imgEl = swiperText[i].querySelector('img')
      if (textEl) {
        text = textEl.textContent
        // text = 'Trucks wait to load containers at a container terminal in Rizhao。Trucks wait to load containers at a container terminal in Rizhao。Trucks wait to load containers at a container terminal in Rizhao。'
      }

      if (imgEl) {
        imgSrc = imgEl.getAttribute('src')
      }
      el.innerHTML = `<div class="scroll-text-left"><img src="${imgSrc || './image/scrollText.svg'}" alt=""></div><div class="swiper-txet">${text}</div>`
      swiperText[i].before(el)
      swiperText[i].remove()
    }

    // 处理图注
    for (let i = 0; i < imgPut.length; i++) {
      const el = document.createElement('div')
      el.innerText = imgPut[i] ? imgPut[i].textContent || '' : ''
      el.classList.add('rmrb-caption-img')
      imgPut[i].before(el)
      imgPut[i].remove()
    }

    // 处理图注2
    for (let i = 0; i < imgPut2.length; i++) {
      const el = document.createElement('div')
      console.log(imgPut2[i].querySelector('.title'))
      el.innerText = imgPut2[i] ? imgPut2[i].querySelector('.title') ? imgPut2[i].querySelector('.title').textContent || '' : '' : ''
      el.classList.add('rmrb-caption-img2')
      imgPut2[i].before(el)
      imgPut2[i].remove()
    }

    // 处理左文右图
    for (let i = 0; i < leftOrRight.length; i++) {
      const imageElList = leftOrRight[i].querySelectorAll('img')

      for (let j = 0; j < imageElList.length; j++) {
        imageElList[j].style.objectFit = 'cover'
        imageElList[j].classList.add('not-preview-image')
      }
    }

    for (let i = 0; i < leftOrRight2.length; i++) {
      const imageElList = leftOrRight2[i].querySelectorAll('img')

      for (let j = 0; j < imageElList.length; j++) {
        imageElList[j].style.objectFit = 'cover'
        imageElList[j].classList.add('not-preview-image')
      }
    }

    // 处理轮播图
    for (let i = 0; i < swiperDom.length; i++) {
      const id = `rmrb-en-swiper_${i + 1}`
      const el = document.createElement('div')
      el.setAttribute('id', `${id}`)
      el.setAttribute('class', `mobile swiper-block`)
      const srcElList = swiperDom[i].querySelectorAll('g foreignObject svg')
      const alEl = swiperDom[i].querySelector('g animateTransform')

      const isLoop = alEl ? alEl.getAttribute('repeatCount') === 'indefinite' : false
      const time = alEl ? alEl.getAttribute('dur') : 0

      const urlList = []

      if (srcElList) {
        for (let j = 0; j < srcElList.length; j++) {
          const backgroundImage = srcElList[j].style.backgroundImage
          const url = backgroundImage.match(/url\("(.+)"\)/)[1]

          if (j !== 0) {
            urlList.push(url)
          }
        }
      }

      let html = '<div class="swiper-wrapper">'

      urlList.forEach(el => {
        html += `<div class="swiper-slide"><img src="${el}" alt=""></div>`
      })

      el.innerHTML = html + `</div><div class="swiper-pagination"></div>`

      swiperDom[i].before(el)
      swiperDom[i].remove()

      nextCallback(3, {
        id: `#${id}`,
        isLoop,
        length: urlList.length,
        time: parseInt(time)
      })
    }

    // 处理海报轮播图
    for (let i = 0; i < swiper2Dom.length; i++) {
      const id = `rmrb-en-poster-swiper_${i + 1}`
      const el = document.createElement('div')
      el.setAttribute('id', `${id}`)
      el.setAttribute('class', `mobile swiper-block`)
      const srcElList = swiper2Dom[i].querySelectorAll('g foreignObject svg')
      const alEl = swiper2Dom[i].querySelector('g animateTransform')

      const isLoop = alEl ? alEl.getAttribute('repeatCount') === 'indefinite' : false
      const time = alEl ? alEl.getAttribute('dur') : 0

      const urlList = []

      if (srcElList) {
        for (let j = 0; j < srcElList.length; j++) {
          const backgroundImage = srcElList[j].style.backgroundImage
          const url = backgroundImage.match(/url\("(.+)"\)/)[1]
          if (j !== 0) {
            urlList.push(url)
          }
        }
      }

      let html = '<div class="swiper-wrapper">'

      urlList.forEach(el => {
        html += `<div class="swiper-slide"><img src="${el}" alt=""></div>`
      })

      el.innerHTML = html + `</div><div class="swiper-pagination"></div>`

      swiper2Dom[i].before(el)
      swiper2Dom[i].remove()

      nextCallback(4, {
        id: `#${id}`,
        isLoop,
        length: urlList.length,
        time: parseInt(time)
      })
    }

    // 处理链接卡片
    for (let i = 0; i < linkCardDom.length; i++) {
      const titleEl = linkCardDom[i].querySelector('span.title') || linkCardDom[i].querySelector('span')

      const title = titleEl ? titleEl.textContent : trim(linkCardDom[i].textContent || '')
      const image = linkCardDom[i].querySelector('img')
      const a = linkCardDom[i].querySelector('a') || linkCardDom[i].querySelector('p:last-child')

      let imageUrl = image ? image.getAttribute('src') : ''

      imageUrl = checkFileType(imageUrl) === '1' ? imageUrl : ''

      const hrefUrl = a
        ? a.getAttribute('href') || a.getAttribute('_href') || a.getAttribute('data-href') || a.textContent
        : ''

      const el = document.createElement('a')
      el.setAttribute('class', imageUrl ? 'preview-link-card-mobile card-image' : 'preview-link-card-mobile')
      el.setAttribute('href', hrefUrl)
      el.setAttribute('target', '_blank')

      let linkIcon = `icon_Y_lianjie_dark`

      const isDark = document.querySelector('html').getAttribute('dark-mode') === 'true'

      if (!isDark) {
        linkIcon = `icon_Y_lianjie`
      }

      if (imageUrl) {
        el.innerHTML = `<div class="left"><img src="${imageUrl}" alt=""></div><div class="right"><div class="preview-link-title droidSerif-bold">${title}</div><div class="preview-link"><img class="not-preview-image" src="./image/${linkIcon}.svg" alt=""><span>${hrefUrl || ''}</span></div></div>`
      } else {
        el.innerHTML = `<div class="preview-link-title droidSerif-bold">${title}</div><div class="preview-link"><img class="not-preview-image" src="./image/${linkIcon}.svg" alt=""><span>${hrefUrl || ''}</span></div>`
      }


      linkCardDom[i].before(el)
      linkCardDom[i].remove()
    }

    // 处理音频
    for (let i = 0; i < audioDom.length; i++) {
      const id = audioDom[i].getAttribute('id') || ''
      const dataId = `en_audio_${i}`
      let audioEl
      let coverEl
      let titleEl
      let title = ''
      let cover = ''
      let audioSrc = ''

      if (id === '_editor36') {
        audioEl = audioDom[i].querySelector('.ueditor_style_audio source')
        coverEl = audioDom[i].querySelector('.audioStyleLeftImg')
        if (!coverEl) {
          coverEl = audioDom[i].querySelector('img.audioStyleLeftImg')
        }
        titleEl = audioDom[i].querySelector('.audioStyleTitle')
        if (titleEl) {
          title = titleEl.innerHTML
        }
        if (audioEl) {
          audioSrc = audioEl.getAttribute('src')
        }
        cover = coverEl ? coverEl.getAttribute('src') || '' : ''
      } else {
        audioEl = audioDom[i].querySelector('.ueditor_style_audio source')
        titleEl = audioDom[i].querySelector('.audioStyleTitle')
        if (titleEl) {
          title = titleEl.innerHTML
        }
        if (audioEl) {
          audioSrc = audioEl.getAttribute('src')
        }
      }

      // cover = ''

      const el = document.createElement('div')
      el.setAttribute('data-id', dataId)
      el.setAttribute('class', cover ? 'preview-audio-player-cover' : 'preview-audio-player')
      const publicImageUrl = './image'
      let pauseIcon = `dark_pause`
      let playIcon = `dark_play`

      const isDark = document.querySelector('html').getAttribute('dark-mode') === 'true'

      if (!isDark) {
        pauseIcon = `audioPause`
        playIcon = `audioPlay`
      }
      const noCoverTitle = `<div class="audio-title ellipsis1 droidSerif-bold">${title}</div>`
      if (cover) {
        el.innerHTML =
          `<audio src="${audioSrc}" class="audio-block hidden"></audio><div class="audio-cover" style="background-image: url('${cover}')"></div><div class="audio-details" style="width: 100%"><div class="audio-title ellipsis1 droidSerif-bold">${title}</div><div class="audio-extral"><div class="audio-time"><span class="audio-current droidSerif">00:00</span><span class="droidSerif audio-current">/</span><span class="audio-durtion droidSerif">00:00</span></div><div class="audio-extral-iocn"><div class="audio-bg"><img src="${publicImageUrl}/audioBg.png" alt=""><img class="audio-play-icon active mobileIcon" src="${publicImageUrl}/${pauseIcon}.svg" alt=""><img class="audio-pause-icon mobileIcon" src="${publicImageUrl}/${playIcon}.svg" alt=""></div></div></div></div>`
      } else {
        el.innerHTML =
          `<audio src="${audioSrc}" class="audio-block hidden"></audio>
            <div class="audio-details"><div class="audio-extral"><div class="left">${title ? noCoverTitle : ''}<div style="font-size: ${title ? undefined : '0.35rem'}" class="audio-time"><span class="audio-current droidSerif">00:00</span><span class="droidSerif audio-current">/</span><span class="audio-durtion droidSerif">00:00</span></div></div><div class="right"><img class="audio-play-icon active" src="${publicImageUrl}/${pauseIcon}.svg" alt=""><img class="audio-pause-icon" src="${publicImageUrl}/${playIcon}.svg" alt=""></div></div></div>`
      }

      if (audioSrc) {
        audioDom[i].before(el)
      }

      audioDom[i].remove()
    }

    const effectImage = []
    for (let i = 0; i < imageDom.length; i++) {
      const name = imageDom[i].getAttribute('data-name')
      const classList = imageDom[i].getAttribute('class') || ''
      const src = imageDom[i].getAttribute('src')
      if (src && src !== 'undefined' && !classList.includes('not-preview-image') && name !== 'people') {
        effectImage.push(imageDom[i])
      }
    }

    for (let i = 0; i < effectImage.length; i++) {
      const photoList = details.photoList || []
      const src = effectImage[i].getAttribute('src')

      if (src) {
        const findRecord = photoList.find(el => {
          const originSrc = src.split('?')[0]
          return handleMediaSrc(el.picPath) == handleMediaSrc(originSrc)
        })
        if (findRecord) {
          const width = findRecord.width || 0
          const height = findRecord.height || 0
          const isDark = document.querySelector('html').getAttribute('dark-mode') === 'true'
          const imageSrc = isDark ? './image/placeHoldVlogo.svg' : './image/placeholdLogo.svg'
          const contentWidth = document.querySelector('.gx-mobile .title')
            ? document.querySelector('.gx-mobile .title').getBoundingClientRect().width
            : 0
          const el = document.createElement('div')
          el.setAttribute('class', 'preview-image-block loading')
          el.style.height = width && height ? `${contentWidth * height / width}px` : 'auto'
          el.innerHTML = `<img class="image-player none image-player-${i}" src="${src}" alt="" data-src="${src}"><img class="preview-image-placehold" src="${imageSrc}" alt=""><img class="preview-image-error none" src="./image/error.svg" alt="">`
          const keysLen = effectImage[i].parentNode.childNodes.length || 0
          if (effectImage[i].parentNode) {
            for (let a = 0; a < keysLen; a += 1) {
              if (effectImage[i].parentNode.childNodes && effectImage[i].parentNode.childNodes.item(a).tagName === 'IMG') {
                if (
                  a > 0 &&
                  effectImage[i].parentNode.childNodes.item(a - 1) &&
                  !!effectImage[i].parentNode.childNodes.item(a - 1).textContent
                ) {
                  el.style.marginTop = '0.6rem'
                }
              }
            }
          }

          effectImage[i].before(el)
          effectImage[i].remove()
          nextCallback(1, src)
        } else {
          const includesTag = 'A'
          if (effectImage[i].parentNode && !includesTag.includes(effectImage[i].parentNode.tagName)) {
            const el = document.createElement('div')
            el.setAttribute('class', 'preview-image-block')
            el.innerHTML = `<img class="image-player none image-player-${i}" src="${src}" alt="" data-src="${src}"><img class="preview-image-placehold none" src="" alt=""><img class="preview-image-error none" src="./image/error.svg" alt="">`
            const keysLen = effectImage[i].parentNode.childNodes.length || 0
            if (effectImage[i].parentNode) {
              for (let a = 0; a < keysLen; a += 1) {
                if (effectImage[i].parentNode.childNodes && effectImage[i].parentNode.childNodes.item(a).tagName === 'IMG') {
                  if (
                    a > 0 &&
                    effectImage[i].parentNode.childNodes.item(a - 1) &&
                    !!effectImage[i].parentNode.childNodes.item(a - 1).textContent
                  ) {
                    el.style.marginTop = '0.6rem'
                  }
                }
              }
            }

            effectImage[i].before(el)
            effectImage[i].remove()
            nextCallback(1, src)
          }
        }
      }
    }

    const videoOutter = []

    for (let i = 0; i < videoDom.length; i++) {
      const parentNode = videoDom[i].parentNode
      if (parentNode.getAttribute('id') === 'article') {
        videoOutter.push(videoDom[i])
      }
    }

    for (let i = 0; i < videoOutter.length; i++) {
      const outterEl = document.createElement('p')
      outterEl.setAttribute('class', 'en-video-outter-content')
      outterEl.append(videoOutter[i].cloneNode())
      videoOutter[i].before(outterEl)
      videoOutter[i].remove()
    }

    const videoDomList = document.querySelectorAll('#article video')

    for (let i = 0; i < videoDomList.length; i++) {
      let width = 0
      let height = 0
      const videoEl = videoDomList[i]
      const videoElId = `origin-video-${i}`
      videoEl.setAttribute('id', videoElId)
      videoEl.setAttribute('class', 'en-origin-video')
      const src = videoDomList[i].getAttribute('src')
      if (!src) break
      if (videoEl && videoEl.style.display === 'none') break
      if (videoDomList[i].getAttribute('style')) {
        const style = videoDomList[i]?.getAttribute('style')?.split(';')
        style.forEach(el => {
          if (el.includes('width') && !el.includes('max')) {
            width = el.includes('width: ') ? el.split('width: ')[1] : el.split('width:')[1]
          } else if (el.includes('height') && !el.includes('max')) {
            height = el.includes('height: ') ? el.split('height: ')[1] : el.split('height:')[1]
          }
        })
      }
      const id = getRandomNumber().uuid(10)
      const poster = videoDomList[i].getAttribute('poster')
      const el = document.createElement('div')
      el.setAttribute('class', 'preview-video init')
      el.innerHTML = `<div id="video-player-${i}" class="video-player video-player-${i}" data-height="${height || '0'}" data-width="${width || '0'}" data-id="${id}"></div>`
      const parentNode = videoDomList[i].parentNode

      if (parentNode) {
        parentNode.before(el)
        parentNode.remove()
      }
      nextCallback(2, { src, id, poster, originId: videoElId })
    }

    const aEl = document.querySelectorAll('#article a')
    for (let i = 0; i < aEl.length; i++) {
      const url = aEl[i].getAttribute('href')
      aEl[i].setAttribute('data-href', url)
      aEl[i].removeAttribute('href')
    }

    const lastEle = document.querySelector('#article')
      ? document.querySelector('#article').lastElementChild : null

    if (lastEle && lastEle.style) {
      if (lastEle.childNodes && lastEle.childNodes.length === 1) {
        if (lastEle.childNodes[0].tagName === 'BR') {
          if (lastEle.previousElementSibling) {
            lastEle.previousElementSibling.style.setProperty('margin-bottom', '0', 'important');
          }
        }
      } else {
        lastEle.style.setProperty('margin-bottom', '0', 'important');
      }
    }
  }

  cloneToContent() {
    const children = $(this.dom).children()
    children.each((_, item) => {
      const el = $(item).clone()
      el.appendTo($('.content'))
    })
    this.$dom().innerHTML = ''
  }

  getDomHeight(dom, style, cssName, str) {
    let height = 0
    const elememt = document.createElement('div')
    elememt.innerText = str
    Object.keys(style).forEach(item => {
      elememt.style[item] = style[item]
    })

    elememt.className = cssName

    document.querySelector(dom).append(elememt)

    height = elememt.getBoundingClientRect().height
    document.querySelector(dom).removeChild(elememt)
    return height
  }
}
