function judgTerminal() {
  const u = navigator.userAgent
  const isXiaomi = u.indexOf('XiaoMi') > -1 // 小米手机
  const isAndroid = u.indexOf('Android') > -1 || u.indexOf('Linux') > -1 // 其它安卓
  const isIOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/) // ios
  if (isAndroid) {
    return 1
  } else if (isIOS) {
    if (isXiaomi) {
      return 1
    } else {
      return 2
    }
  }
}

function setupWebViewJavascriptBridge(callback) {
  if (window.WebViewJavascriptBridge) { return callback(WebViewJavascriptBridge) }
  if (window.WVJBCallbacks) { return window.WVJBCallbacks.push(callback) }
  window.WVJBCallbacks = [ callback ]
  var WVJBIframe = document.createElement('iframe')
  WVJBIframe.style.display = 'none'
  WVJBIframe.src = 'https://__bridge_loaded__'
  document.documentElement.appendChild(WVJBIframe)
  setTimeout(function () { document.documentElement.removeChild(WVJBIframe) }, 0)
}

function connectWebViewJavascriptBridge(callback) {
  if (window.WebViewJavascriptBridge && WebViewJavascriptBridge.inited) {
    callback(WebViewJavascriptBridge)
  } else {
    document.addEventListener(
      'WebViewJavascriptBridgeReady'
      , function () {
        // console.log('WebViewJavascriptBridge==>',WebViewJavascriptBridge);
        callback(WebViewJavascriptBridge)
      },
      false
    )
  }
}

function sendNative(name, data, callback) {
  if (!window.WebViewJavascriptBridge) return
  if (judgTerminal() === 1) {
    window.WebViewJavascriptBridge.callHandler(name, data, function (responseData) {
      if (callback) callback(responseData)
    })
  } else {
    window.WebViewJavascriptBridge.callHandler(name, data, function (response) {
      if (callback) callback(response)
    })
  }
}

function connetAppLogin() {
  if (judgTerminal() === 1) {
    connectWebViewJavascriptBridge(function (bridge) {
      bridge.registerHandler('jsCall_appNotifyEvent', function (data, responseCallback) {
        window.config.VUE_APP_LOGIN = data
        if (document.querySelector('#notice-change')) {
          document.querySelector('#notice-change').click()
        }
        if (responseCallback) responseCallback(data)
      })
    })
  } else {
    setupWebViewJavascriptBridge(function (bridge) {
      bridge.registerHandler('jsCall_appNotifyEvent', function (data, responseCallback) {
        window.config.VUE_APP_LOGIN = data
        if (document.querySelector('#notice-change')) {
          document.querySelector('#notice-change').click()
        }
        if (responseCallback) responseCallback(data)
      })
    })
  }
}

function networkStatus() {
  if (judgTerminal() === 1) {
    connectWebViewJavascriptBridge(function (bridge) {
      bridge.registerHandler('jsCall_appNetworkStatusChangedEvent', function (data, responseCallback) {
        window.config.VUE_APP_NETWORK = data
        if (document.querySelector('#network-change')) {
          document.querySelector('#network-change').click()
        }
        if (responseCallback) responseCallback(data)
      })
    })
  } else {
    setupWebViewJavascriptBridge(function (bridge) {
      bridge.registerHandler('jsCall_appNetworkStatusChangedEvent', function (data, responseCallback) {
        window.config.VUE_APP_NETWORK = data
        if (document.querySelector('#network-change')) {
          document.querySelector('#network-change').click()
        }
        if (responseCallback) responseCallback(data)
      })
    })
  }
}

$(function () {
  if (judgTerminal() === 1) {
    connectWebViewJavascriptBridge(function (bridge) {
      bridge.registerHandler('jsCall_receiveAppData', function (data, responseCallback) {
        window.config.VUE_CONTENT_CONFIG = data
        if (responseCallback) responseCallback(data)
      })
    })
  } else {
    setupWebViewJavascriptBridge(function (bridge) {
      bridge.registerHandler('jsCall_receiveAppData', function (data, responseCallback) {
        window.config.VUE_CONTENT_CONFIG = data
        if (responseCallback) responseCallback(data)
      })
    })
  }
  connetAppLogin()
  networkStatus()

  // setTimeout(() => {
  //   window.config.VUE_APP_NETWORK = 5
  //
  //   if (document.querySelector('#network-change')) {
  //     document.querySelector('#network-change').click()
  //   }
  // }, 6000)
  //
  // setTimeout(() => {
  //   window.config.VUE_APP_NETWORK = 1
  //
  //   if (document.querySelector('#network-change')) {
  //     document.querySelector('#network-change').click()
  //   }
  // }, 2000)
  //
  // setTimeout(() => {
  //   window.config.VUE_APP_NETWORK = 4
  //
  //   if (document.querySelector('#network-change')) {
  //     document.querySelector('#network-change').click()
  //   }
  // }, 3000)
})
