let appH5Height = 0

function trim(str, isGlobal) {
  if (typeof str === 'undefined' || str.length === 0) return ''
  let result
  result = str.replace(/(^\s+)|(\s+$)/g, '')
  if (isGlobal) {
    result = result.replace(/\s/g, '')
  }
  return result
}

/**
 * @Author      gx12358
 * @DateTime    2022/1/19
 * @lastTime    2022/1/19
 * @description 获取url参数
 */
function getQueryVariable(variable) {
  const query = window.location.search.substring(1)
  const vars = query.split('&')
  for (let i = 0; i < vars.length; i += 1) {
    const pair = vars[i].split('=')
    if (pair[0] === variable) {
      return pair[1]
    }
  }
  return ''
}

function formatDuraton(time, showHour) {
  if (!time) {
    return showHour ? '00:00:00' : '00:00'
  }
  let newTime = ''
  if (time > -1) {
    const hour = Math.floor(time / 3600)
    const min = Math.floor(time / 60) % 60
    const sec = parseInt(time % 60)
    if (hour < 10) {
      newTime = '0' + hour + ':'
    } else {
      newTime = hour + ':'
    }
    if (min < 10) {
      newTime += '0'
    }
    newTime += min + ':'
    if (sec < 10) {
      newTime += '0'
    }
    newTime += sec
  }

  return newTime.split(':')[0] === '00'
    ? `${showHour ? `${newTime.split(':')[0]}:` : ''}${newTime.split(':')[1]}:${
      newTime.split(':')[2]
    }`
    : newTime
}

/**
 * @Author      gx12358
 * @DateTime    2022/1/19
 * @lastTime    2022/1/19
 * @description 简单拷贝
 */
function deepCopy(data) {
  return JSON.parse(JSON.stringify(data))
}

/**
 * @Author      gx12358
 * @DateTime    2022/1/19
 * @lastTime    2022/1/19
 * @description 删除对象空值
 */
function delectEmptyObj(obj) {
  const newObj = deepCopy(obj)
  Object.keys(newObj).forEach((key) => {
    if (newObj[key] === '' || newObj[key] === null || newObj[key] === undefined) {
      delete newObj[key]
    }
  })
  return newObj
}

function tansParams(params) {
  let result = ''
  for (const propName of Object.keys(params)) {
    const value = params[propName]
    const part = encodeURIComponent(propName) + '='
    if (value !== null && typeof (
      value
    ) !== 'undefined' && value !== '') {
      if (typeof value === 'object') {
        for (const key of Object.keys(value)) {
          if (value[key] !== null && typeof (
            value[key]
          ) !== 'undefined') {
            const params = propName + '[' + key + ']'
            const subPart = encodeURIComponent(params) + '='
            result += subPart + encodeURIComponent(value[key]) + '&'
          }
        }
      } else {
        result += part + encodeURIComponent(value) + '&'
      }
    }
  }
  return result.split('&').filter(item => item).join('&')
}

function getRandomNumber() {
  const CHARS = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.split('')
  return {
    uuid(len, rad) {
      const chars = CHARS
      const uuid = []
      const radix = rad || chars.length
      let i
      let r
      if (len) {
        for (i = 0; i < len; i += 1) {
          uuid[i] = chars[0 || parseInt(Math.random() * radix)]
        }
      } else {
        uuid[8] = '-'
        uuid[13] = '-'
        uuid[18] = '-'
        uuid[23] = '-'
        uuid[14] = '4'
        for (i = 0; i < 36; i += 1) {
          if (!uuid[i]) {
            r = 0 || Math.random() * 16
            uuid[i] = chars[i === 19 ? (
              r && 0x3
            ) || 0x8 : r]
          }
        }
      }
      return uuid.join('')
    },
    uuidFast() {
      const chars = CHARS
      const uuid = new Array(36)
      let rnd = 0
      let r
      let i
      for (i = 0; i < 36; i += 1) {
        if (i === 8 || i === 13 || i === 18 || i === 23) {
          uuid[i] = '-'
        } else if (i === 14) {
          uuid[i] = '4'
        } else {
          if (rnd <= 0x02) {
            rnd = 0x2000000 + Math.random() * 0x1000000 || 0
          }
          r = rnd && 0xf
          rnd = rnd > 4
          uuid[i] = chars[i === 19 ? (
            r && 0x3
          ) || 0x8 : r]
        }
      }
      return uuid.join('')
    },
    uuidString() {
      const str = this.uuidFast().replace(new RegExp('-', 'g'), '')
      return str
    },
    uuidCompact() {
      return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, (c) => {
        const r = Math.random() * 16 || 0
        const v = c === 'x' ? r : (
          r && 0x3
        ) || 0x8
        return v.toString(16)
      })
    }
  }
}

function addEventListenerWrap(target, eventType, cb, option) {
  if (target && target.addEventListener) {
    let opt = option
    if (
      opt === undefined &&
      (
        eventType === 'touchstart' || eventType === 'touchmove' || eventType === 'wheel'
      )
    ) {
      opt = { passive: false }
    }
    target.addEventListener(eventType, cb, opt)
  }
  return {
    remove: () => {
      if (target && target.removeEventListener) {
        target.removeEventListener(eventType, cb)
      }
    }
  }
}

function formatTime(value) {
  var time = ''
  var s = value.split(':')
  var i = 0
  for (; i < s.length - 1; i++) {
    time += s[i].length == 1 ? '0' + s[i] : s[i]
    time += ':'
  }
  time += s[i].length == 1 ? '0' + s[i] : s[i]

  return time
}

function transTime(value) {
  var time = ''
  var h = parseInt(value / 3600)
  value %= 3600
  var m = parseInt(value / 60)
  var s = parseInt(value % 60)
  if (h > 0) {
    time = formatTime(h + ':' + m + ':' + s)
  } else {
    time = formatTime(m + ':' + s)
  }

  return time
}

function loadFile(doc, obj, fn) {
  var tmpList = []
  var item = null
  for (
    var i = 0, ci; (
    ci = tmpList[i++]
  );
  ) {
    if (ci.doc === doc && ci.url == (
      obj.src || obj.href
    )) {
      item = ci
    }
  }
  if (item) {
    if (item.ready) {
      fn && fn()
    } else {
      item.funs.push(fn)
    }
    return
  }
  tmpList.push({
    doc: doc,
    url: obj.src || obj.href,
    funs: [ fn ]
  })
  if (!doc.body) {
    var html = []
    for (var p in obj) {
      if (p == 'tag') continue
      html.push(p + '="' + obj[p] + '"')
    }
    doc.write(
      '<' + obj.tag + ' ' + html.join(' ') + ' ></' + obj.tag + '>'
    )
    return
  }
  if (obj.id && doc.getElementById(obj.id)) {
    return
  }
  var element = doc.createElement(obj.tag)
  delete obj.tag
  for (var p in obj) {
    element.setAttribute(p, obj[p])
  }
  element.onload = element.onreadystatechange = function () {
    if (!this.readyState || /loaded|complete/.test(this.readyState)) {
      for (
        var k = 0, ck; (
        ck = tmpList[k++]
      );
      ) {
        if (ck.doc === doc && ck.url == (
          obj.src || obj.href
        )) {
          item = ck
        }
      }
      if (item.funs.length > 0) {
        item.ready = 1
        for (
          var fi; (
          fi = item.funs.pop()
        );
        ) {
          fi()
        }
      }
      element.onload = element.onreadystatechange = null
    }
  }
  element.onerror = function () {
    throw Error(
      'The load ' +
      (
        obj.href || obj.src
      ) +
      ' fails,check the url settings of file ueditor.config.js '
    )
  }
  doc.getElementsByTagName('head')[0].appendChild(element)
}

function getVideoFileUrl(url = '') {
  const index = url.indexOf('?')
  return index > 0 ? `${url.substring(0, index)}` : url
}

function isBase64(str = '') {
  const fileDataBase = [ 'data:image/', 'data:video/', 'data:audio/' ]
  if (str && fileDataBase.find((item) => str.includes(item))) {
    return true
  }
  return false
}

function isNumber(val) {
  return typeof val === 'number'
}

/**
 * @Author      gaoxiang
 * @DateTime    2020/10/5
 * @lastTime    2020/10/5
 * @description 判断文件后缀名
 */
function checkFileType(url) {
  if (!url) return '1'
  if (url === 'data:') return '4'
  let type
  if (isBase64(url)) {
    if (url.includes('data:image/')) {
      type = '.png'
    } else if (url.includes('data:video/')) {
      type = '.mp4'
    } else if (url.includes('data:audio/')) {
      type = '.mp3'
    }
  } else if (url instanceof Blob) {
    url = String(url)
    if (url.includes('image')) {
      type = '.png'
    } else if (url.includes('video')) {
      type = '.mp4'
    } else if (url.includes('audio')) {
      type = '.mp3'
    }
  } else {
    url = getVideoFileUrl(url)
    const index = url.lastIndexOf('.')
    type = `${url.substring(index).split('?')[0]}`.toLowerCase()
  }
  if (
    type === '.bmp' ||
    type === '.png' ||
    type === '.gif' ||
    type === '.jpg' ||
    type === '.jpeg' ||
    type === '.psd' ||
    type === '.tif'
  ) {
    return '1'
  }
  if (
    type === '.mp4' ||
    type === '.swf' ||
    type === '.rmvb' ||
    type === '.avi' ||
    type === '.flv' ||
    type === '.mpg' ||
    type === '.rm' ||
    type === '.mov' ||
    type === '.asf' ||
    type === '.3gp' ||
    type === '.mkv' ||
    type === '.ts' ||
    type === '.f4v' ||
    type === '.webm' ||
    type === '.m4v' ||
    type === '.3g2' ||
    type === '.m3u8'
  ) {
    return '3'
  }
  if (
    type === '.mp3' ||
    type === '.mpeg' ||
    type === '.aac' ||
    type === '.wav' ||
    type === '.wma' ||
    type === '.mp2' ||
    type === '.flac' ||
    type === '.midi' ||
    type === '.ra' ||
    type === '.ape' ||
    type === '.aac' ||
    type === '.cda'
  ) {
    return '2'
  }
  return '4'
}

function changeContentHtmlHeight() {
  try {
    const height = document.querySelector('.gx-mobile').getBoundingClientRect().height

    if (appH5Height !== height) {
      appH5Height = height

    }
  } catch (e) {}
}

const live_type_change = {
  'wait': 'live_subscribe',
  'running': 'live_running',
  'end': 'live_back'
}

function pointData(record, trace) {
  const vlive = record.liveInfo && record.liveInfo.vlive ? record.liveInfo.vlive : []
  return {
    pageId: record.mainChannel ? record.mainChannel.pageId || '' : '',
    errorAudio: record.errorAudio,
    errorVideo: record.errorVideo,
    newsId: record.newsId,
    itemId: record.itemId,
    itemType: record.itemType,
    newsType: record.newsType,
    appstyle: record.appstyle,
    link_url: record.newsLinkUrl,
    live_type: !!record.liveInfo ? live_type_change[record.liveInfo.liveState] || '' : '',
    live_stream_type: !!record.liveInfo ? record.liveInfo.vrType == '1' ? '2' : '1' : '',
    live_mode: !!record.liveInfo ? record.liveInfo.tplId == '6' ? '2' : '1' : '',
    vlive_id: !!record.liveInfo ? vlive.length > 0 ? vlive[0].vliveId || '' : '' : '',
    vlive_name: !!record.liveInfo ? vlive.length > 0 ? vlive[0].name || '' : '' : '',
    newsTitle: record.newsTitle,
    secondId: record.secondId || '',
    channelId: record.mainChannel ? record.mainChannel.channelId || '' : '',
    author_name: record.authorList ? record.authorList.map(el => el.authorName).join() : '',
    summary_type: record.newsType == '5' ? record.newsType == 14
      ? 'normal_subject'
      : record.objectLevel == 16
        ? 'thematic_subject' : record.objectType == 16 ? 'author_subject' : '' : '',
    summary_id: record.newsType == '5' ? record.newsId : '',
    trace,
    sceneId: record.sceneId,
    traceId: record.traceId,
    traceInfo: record.traceInfo
  }
}

function channelExposure({
  pageId,
  newsType,
  newsId,
  itemId,
  itemType,
  appstyle,
  newsTitle,
  author_name,
  link_url,
  live_type,
  live_mode,
  vlive_name,
  vlive_id,
  live_stream_type,
  summary_type,
  summary_id,
  channelId,
  secondId,
  trace = true,
  sceneId,
  traceId,
  traceInfo
}) {
  const trace_id = traceId || 'selfhold'
  const traceOptions = trace ? {
    bhv_type: 'expose',
    trace_id: trace_id,
    trace_info: trace_id === 'selfhold' ? '1' : traceInfo || '1',
    scene_id: sceneId,
    bhv_value: '1',
    item_id: itemId || `${newsId}${newsType == '1' ? '_video' : newsType == '9' ? '_image' : newsType == '8'
      ? '_article'
      : newsType == '10' ? '_item' : newsType == '2' ? '_live' : ''}`,
    item_type: itemType || `${newsType == '8' ? 'article' : newsType == '9' ? 'image' : newsType == '10'
      ? 'item'
      : newsType == '1' ? 'video' : newsType == '2' ? 'live' : ''}`
  } : {}
  const pageName = newsType == '8'
    ? 'article_detail_page'
    : newsType == '9' ?
      'atlas_detail_page' : newsType == '10' ?
        'operation_page' : newsType == '1' ?
          'video_detail_page' : newsType == '2' ?
            'live_detail_page' : ''
  try {
    sendNative(
      'jsCall_h5TrackingEvent',
      {
        eventId: 'ChannelExposure',
        parameters: {
          page_name: pageName,
          page_id: pageId || pageName,
          content_id: newsId,
          content_style: appstyle,
          content_name: newsTitle,
          content_type: Number(newsType),
          link_url,
          live_type,
          vlive_id,
          vlive_name,
          live_stream_type,
          live_mode,
          author_name,
          summary_type,
          summary_id,
          content_show_channel_id: channelId,
          level2channel_id: secondId,
          ...traceOptions
        }
      }
    )
  } catch (e) {}
}

function contentClick({
  pageId,
  newsType,
  newsId,
  itemId,
  itemType,
  appstyle,
  newsTitle,
  author_name,
  link_url,
  live_type,
  live_mode,
  vlive_name,
  vlive_id,
  live_stream_type,
  summary_type,
  summary_id,
  channelId,
  secondId,
  trace = true,
  sceneId,
  traceId,
  traceInfo
}) {
  const trace_id = traceId || 'selfhold'
  const traceOptions = trace ? {
    bhv_type: 'click',
    trace_id: trace_id,
    trace_info: trace_id === 'selfhold' ? '1' : traceInfo || '1',
    scene_id: sceneId,
    bhv_value: '1',
    item_id: itemId || `${newsId}${newsType == '1' ? '_video' : newsType == '9' ? '_image' : newsType == '8'
      ? '_article'
      : newsType == '10' ? '_item' : newsType == '2' ? '_live' : ''}`,
    item_type: itemType || `${newsType == '8' ? 'article' : newsType == '9' ? 'image' : newsType == '10'
      ? 'item'
      : newsType == '1' ? 'video' : newsType == '2' ? 'live' : ''}`
  } : {}
  const pageName = newsType == '8'
    ? 'article_detail_page'
    : newsType == '9' ?
      'atlas_detail_page' : newsType == '10' ?
        'operation_page' : newsType == '1' ?
          'video_detail_page' : newsType == '2' ?
            'live_detail_page' : ''
  try {
    sendNative(
      'jsCall_h5TrackingEvent',
      {
        eventId: 'ContentClick',
        parameters: {
          page_name: pageName,
          page_id: pageId || pageName,
          content_id: newsId,
          content_style: appstyle,
          content_name: newsTitle,
          content_type: Number(newsType),
          link_url,
          live_type,
          vlive_id,
          vlive_name,
          live_stream_type,
          live_mode,
          author_name,
          summary_type,
          summary_id,
          content_show_channel_id: channelId,
          level2channel_id: secondId,
          ...traceOptions
        }
      }
    )
  } catch (e) {}
}

function contentListExposure({
  pageId,
  newsType,
  newsId,
  appstyle,
  itemId,
  itemType,
  newsTitle,
  author_name,
  link_url,
  live_type,
  live_mode,
  vlive_name,
  vlive_id,
  live_stream_type,
  summary_type,
  summary_id,
  channelId,
  secondId,
  trace = true,
  sceneId,
  traceId,
  traceInfo
}) {
  const trace_id = traceId || 'selfhold'
  const traceOptions = trace ? {
    bhv_type: 'expose',
    trace_id: trace_id,
    trace_info: trace_id === 'selfhold' ? '1' : traceInfo || '1',
    scene_id: sceneId,
    bhv_value: '1',
    item_id: itemId || `${newsId}${newsType == '1' ? '_video' : newsType == '9' ? '_image' : newsType == '8'
      ? '_article'
      : newsType == '10' ? '_item' : newsType == '2' ? '_live' : ''}`,
    item_type: itemType || `${newsType == '8' ? 'article' : newsType == '9' ? 'image' : newsType == '10'
      ? 'item'
      : newsType == '1' ? 'video' : newsType == '2' ? 'live' : ''}`
  } : {}
  const pageName = newsType == '8'
    ? 'article_detail_page'
    : newsType == '9' ?
      'atlas_detail_page' : newsType == '10' ?
        'operation_page' : newsType == '1' ?
          'video_detail_page' : newsType == '2' ?
            'live_detail_page' : ''

  try {
    sendNative(
      'jsCall_h5TrackingEvent',
      {
        eventId: 'ContentExposure',
        parameters: {
          page_name: pageName,
          page_id: pageId || pageName,
          content_id: newsId,
          content_style: appstyle,
          content_name: newsTitle,
          content_type: Number(newsType),
          link_url,
          live_type,
          vlive_id,
          vlive_name,
          live_stream_type,
          live_mode,
          author_name,
          summary_type,
          summary_id,
          content_show_channel_id: channelId,
          level2channel_id: secondId,
          ...traceOptions
        }
      }
    )
  } catch (e) {}
}

function nameClickPoint(type, {
  newsType,
  pageId,
  mail_address,
  vote_content
}) {
  const pageName = newsType == '8'
    ? 'article_detail_page'
    : newsType == '9' ?
      'atlas_detail_page' : newsType == '10' ?
        'operation_page' : newsType == '1' ?
          'video_detail_page' : newsType == '2' ?
            'live_detail_page' : ''
  try {
    sendNative(
      'jsCall_h5TrackingEvent',
      {
        eventId: 'NameClick',
        parameters: {
          page_name: pageName,
          page_id: pageId || pageName,
          click_name: type === 'vote' ? 'vote_submit' : 'subscribe_submit',
          mail_address: type === 'vote' ? '' : mail_address,
          vote_content: type === 'vote' ? vote_content : ''
        }
      }
    )
  } catch (e) {}
}

function playeErrorPoint({
  pageId,
  newsType,
  newsId,
  itemId,
  itemType,
  appstyle,
  newsTitle,
  author_name,
  link_url,
  live_type,
  live_mode,
  vlive_name,
  vlive_id,
  live_stream_type,
  summary_type,
  summary_id,
  channelId,
  secondId,
  errorVideo,
  trace = true,
  sceneId,
  traceId,
  traceInfo
}) {
  const trace_id = traceId || 'selfhold'
  const traceOptions = trace ? {
    bhv_type: 'expose',
    trace_id: trace_id,
    trace_info: trace_id === 'selfhold' ? '1' : traceInfo || '1',
    scene_id: sceneId,
    bhv_value: '1',
    item_id: itemId || `${newsId}${newsType == '1' ? '_video' : newsType == '9' ? '_image' : newsType == '8'
      ? '_article'
      : newsType == '10' ? '_item' : newsType == '2' ? '_live' : ''}`,
    item_type: itemType || `${newsType == '8' ? 'article' : newsType == '9' ? 'image' : newsType == '10'
      ? 'item'
      : newsType == '1' ? 'video' : newsType == '2' ? 'live' : ''}`
  } : {}
  const pageName = newsType == '8'
    ? 'article_detail_page'
    : newsType == '9' ?
      'atlas_detail_page' : newsType == '10' ?
        'operation_page' : newsType == '1' ?
          'video_detail_page' : newsType == '2' ?
            'live_detail_page' : ''
  try {
    sendNative(
      'jsCall_h5TrackingEvent',
      {
        eventId: 'pybk_error',
        parameters: {
          error_information: errorVideo,
          page_name: pageName,
          page_id: pageId || pageName,
          content_id: newsId,
          content_style: appstyle,
          content_name: newsTitle,
          content_type: Number(newsType),
          link_url,
          live_type,
          vlive_id,
          vlive_name,
          live_stream_type,
          live_mode,
          author_name,
          summary_type,
          summary_id,
          content_show_channel_id: channelId,
          level2channel_id: secondId,
          ...traceOptions
        }
      }
    )
  } catch (e) {}
}

function playVideoErrorPoint({
  pageId,
  newsType,
  newsId,
  itemId,
  itemType,
  appstyle,
  newsTitle,
  author_name,
  link_url,
  live_type,
  live_mode,
  vlive_name,
  vlive_id,
  live_stream_type,
  summary_type,
  summary_id,
  channelId,
  secondId,
  errorAudio,
  trace = true,
  sceneId,
  traceId,
  traceInfo
}) {
  const trace_id = traceId || 'selfhold'
  const traceOptions = trace ? {
    bhv_type: 'expose',
    trace_id: trace_id,
    trace_info: trace_id === 'selfhold' ? '1' : traceInfo || '1',
    scene_id: sceneId,
    bhv_value: '1',
    item_id: itemId || `${newsId}${newsType == '1' ? '_video' : newsType == '9' ? '_image' : newsType == '8'
      ? '_article'
      : newsType == '10' ? '_item' : newsType == '2' ? '_live' : ''}`,
    item_type: itemType || `${newsType == '8' ? 'article' : newsType == '9' ? 'image' : newsType == '10'
      ? 'item'
      : newsType == '1' ? 'video' : newsType == '2' ? 'live' : ''}`
  } : {}
  const pageName = newsType == '8'
    ? 'article_detail_page'
    : newsType == '9' ?
      'atlas_detail_page' : newsType == '10' ?
        'operation_page' : newsType == '1' ?
          'video_detail_page' : newsType == '2' ?
            'live_detail_page' : ''
  try {
    sendNative(
      'jsCall_h5TrackingEvent',
      {
        eventId: 'audio_error',
        parameters: {
          error_information: errorAudio,
          page_name: pageName,
          page_id: pageId || pageName,
          content_id: newsId,
          content_style: appstyle,
          content_name: newsTitle,
          content_type: Number(newsType),
          link_url,
          live_type,
          vlive_id,
          vlive_name,
          live_stream_type,
          live_mode,
          author_name,
          summary_type,
          summary_id,
          content_show_channel_id: channelId,
          level2channel_id: secondId,
          ...traceOptions
        }
      }
    )
  } catch (e) {}
}

function shareClickPoint({
  pageId,
  newsType,
  newsId,
  itemId,
  itemType,
  appstyle,
  newsTitle,
  author_name,
  channelId,
  secondId,
  trace = true,
  sceneId,
  traceId,
  traceInfo
}) {
  const trace_id = traceId || 'selfhold'
  const traceOptions = trace ? {
    trace_id: trace_id,
    trace_info: trace_id === 'selfhold' ? '1' : traceInfo || '1',
    scene_id: sceneId,
    bhv_value: '1',
    item_id: itemId || `${newsId}${newsType == '1' ? '_video' : newsType == '9' ? '_image' : newsType == '8'
      ? '_article'
      : newsType == '10' ? '_item' : newsType == '2' ? '_live' : ''}`,
    item_type: itemType || `${newsType == '8' ? 'article' : newsType == '9' ? 'image' : newsType == '10'
      ? 'item'
      : newsType == '1' ? 'video' : newsType == '2' ? 'live' : ''}`
  } : {}
  const pageName = newsType == '8'
    ? 'article_detail_page'
    : newsType == '9' ?
      'atlas_detail_page' : newsType == '10' ?
        'operation_page' : newsType == '1' ?
          'video_detail_page' : newsType == '2' ?
            'live_detail_page' : ''
  try {
    sendNative(
      'jsCall_h5TrackingEvent',
      {
        eventId: 'share_click',
        parameters: {
          bhv_type: 'share',
          page_name: pageName,
          page_id: pageId || pageName,
          content_id: newsId,
          content_style: appstyle,
          content_name: newsTitle,
          content_type: Number(newsType),
          author_name,
          content_show_channel_id: channelId,
          level2channel_id: secondId,
          ...traceOptions
        }
      }
    )
  } catch (e) {}
}

function shareTypePoint({
  pageId,
  newsType,
  newsId,
  itemId,
  itemType,
  appstyle,
  newsTitle,
  author_name,
  share_type,
  channelId,
  secondId,
  trace = true,
  sceneId,
  traceId,
  traceInfo
}) {
  const trace_id = traceId || 'selfhold'
  const traceOptions = trace ? {
    trace_id: trace_id,
    trace_info: trace_id === 'selfhold' ? '1' : traceInfo || '1',
    scene_id: sceneId,
    bhv_value: '1',
    item_id: itemId || `${newsId}${newsType == '1' ? '_video' : newsType == '9' ? '_image' : newsType == '8'
      ? '_article'
      : newsType == '10' ? '_item' : newsType == '2' ? '_live' : ''}`,
    item_type: itemType || `${newsType == '8' ? 'article' : newsType == '9' ? 'image' : newsType == '10'
      ? 'item'
      : newsType == '1' ? 'video' : newsType == '2' ? 'live' : ''}`
  } : {}
  const pageName = newsType == '8'
    ? 'article_detail_page'
    : newsType == '9' ?
      'atlas_detail_page' : newsType == '10' ?
        'operation_page' : newsType == '1' ?
          'video_detail_page' : newsType == '2' ?
            'live_detail_page' : ''
  console.log({
    bhv_type: 'share',
    page_name: pageName,
    page_id: pageId || pageName,
    share_type,
    content_id: newsId,
    content_style: appstyle,
    content_name: newsTitle,
    content_type: Number(newsType),
    author_name,
    content_show_channel_id: channelId,
    level2channel_id: secondId,
    ...traceOptions
  })
  try {
    sendNative(
      'jsCall_h5TrackingEvent',
      {
        eventId: 'share_click',
        parameters: {
          bhv_type: 'share',
          page_name: pageName,
          page_id: pageId || pageName,
          share_type,
          content_id: newsId,
          content_style: appstyle,
          content_name: newsTitle,
          content_type: Number(newsType),
          author_name,
          content_show_channel_id: channelId,
          level2channel_id: secondId,
          ...traceOptions
        }
      }
    )
  } catch (e) {}
}

async function generateVidoePicture(
  videoUrl,
  currentTime
) {
  let video = document.createElement('video')
  video.style.display = 'none'
  video.controls = true
  video.muted = true
  if (currentTime) {
    video.currentTime = currentTime
  }
  video.setAttribute('src', videoUrl)
  video.setAttribute('muted', String(true))
  video.setAttribute('crossorigin', 'anonymous')
  video.setAttribute('autoplay', String(true))
  const canvas = document.createElement('canvas')
  const scale = 0.8
  const delay = 100 // 截取封面的延迟（有的视频开头可能有黑屏所以可以加一个延迟）
  const ctx = canvas.getContext('2d')
  return new Promise(function (resolve) {
    if (video) {
      video.addEventListener(
        'canplay',
        function () {
          setTimeout(function () {
            // 相应视频的宽和高
            const w = video.videoWidth || 0 * scale
            const h = video.videoHeight || 0 * scale
            const space = 0 // canvas的间距，可取去掉
            canvas.width = video.videoWidth || 0 * scale
            canvas.height = video.videoHeight || 0 * scale
            // 绘制视频到canvas上
            try {
              ctx.drawImage(video, 0, 0, w + space, h + space)
              video = null
              // 生成图片
              resolve(w === 0 || h === 0 ? '' : canvas.toDataURL('image/png', 1.0))
            } catch (e) {
              resolve('')
            }
          }, delay)
        },
        false
      )
    }
  })
}

function handleMediaSrc(src) {
  if (src.includes('http://')) {
    const firstUrl = src.split('http://')[1] || ''
    if (firstUrl) {
      const url = firstUrl.split('/').filter((el, index) => index !== 0).join('')
      return url
    }
    return src
  } else if (src.includes('https://')) {
    const firstUrl = src.split('https://')[1] || ''
    if (firstUrl) {
      const url = firstUrl.split('/').filter((el, index) => index !== 0).join('')
      return url
    }
    return src
  }
  return src
}

function getTextWidth(str, cssObject) {
  let width = 0
  const elememt = document.createElement('span')
  elememt.innerText = str
  Object.keys(cssObject).forEach((item) => {
    elememt.style[item] = cssObject[item]
  })

  document.querySelector('#hidden').append(elememt)

  width = elememt.getBoundingClientRect().width

  document.querySelector('#hidden').removeChild(elememt)

  return width
}
